#include <stdio.h>

int main() {
    int array[8][8], row, col;

    /* read input */
    for (row = 0; row < 8; row++) {
        for (col = 0; col < 8; col++) {
            scanf("%d", &array[row][col]);
        }
    }

    /* start at top left */
    row = col = 0;
    printf("11\n");

    /* keep looping */
    while (1) {
        int value = array[row][col];

        /* check if we found it */
        if (value == 0) {
            printf("Found the fossil!\n");
            break;
        }

        /* check if we looped */
        if (value == -1) {
            printf("Fossil not found!\n");
            break;
        }

        /* print the number */
        printf("%d\n", value);

        /* overwrite so we know we been here */
        array[row][col] = -1;

        /* get next location */
        row = value / 10 - 1;
        col = value % 10 - 1;
    }

    return 0;
}

